#!/usr/bin/env python3

import math
import matplotlib.pyplot as plt
import astropy.io.fits as fits
#import astropy.io.fits
import random
#import astropy.io.fits as pyfits
import csv
import numpy as np
from scipy.interpolate import interp1d
from scipy.spatial import geometric_slerp
import tkinter as tk
from tkinter import ttk
import time
from spherical_geometry.polygon import SphericalPolygon
import sys
import os


def delete():
    root.destroy()

def create_gui():
    global entry1, entry2, entry3, entry4, entry5, entry6, entry7, entry8, entry9, entry10, root
    
    # Creazione della finestra principale
    root = tk.Tk()
    root.title("Input parameters")

    # Creazione delle label e dei campi di testo per i parametri
    label1 = tk.Label(root, text="Number of modules per column", font=('Times', 14, 'bold'))
    entry1 = tk.Entry(root)
    entry1.insert(0, "4")

    label2 = tk.Label(root, text="Number of modules per row", font=('Times', 14, 'bold'))
    entry2 = tk.Entry(root)
    entry2.insert(0, "4")

    label3 = tk.Label(root, text="Single Module size x (cm)", font=('Times', 14, 'bold'))
    entry3 = tk.Entry(root)
    entry3.insert(0, "5")

    label4 = tk.Label(root, text="Single Module size y (cm)", font=('Times', 14, 'bold'))
    entry4 = tk.Entry(root)
    entry4.insert(0, "5")

    label5 = tk.Label(root, text="Heigth of the collimator (cm)", font=('Times', 14, 'bold'))
    entry5 = tk.Entry(root)
    entry5.insert(0, "20")

    label6 = tk.Label(root, text="Significance (sigma)", font=('Times', 14, 'bold'))
    entry6 = tk.Entry(root)
    entry6.insert(0, "7")

    label7 = tk.Label(root, text="Number of extracted GRBs", font=('Times', 14, 'bold'))
    entry7 = tk.Entry(root)
    entry7.insert(0, "25300")

    label8 = tk.Label(root, text="Type of GRBs (0 = long, 1 = short)", font=('Times', 14, 'bold'))
    entry8 = tk.Entry(root)
    entry8.insert(0, "0")

    label9 = tk.Label(root, text="How many cameras \n simmetrically distributed \n around the P/L axis", font=('Times', 14, 'bold'))
    entry9 = tk.Entry(root)
    entry9.insert(0, "6")

    label10 = tk.Label(root, text="Theta for each camera \n (wrt the P/L axis)", font=('Times', 14, 'bold'))
    #entry9 = tk.Entry(root)
    #entry9.insert(0, "20")
    
    # Posizionamento degli elementi nella finestra
    label1.grid(row=0, column=0, padx=10, pady=8)
    entry1.grid(row=0, column=1, padx=10, pady=8)

    label2.grid(row=0, column=2, padx=10, pady=8)
    entry2.grid(row=0, column=3, padx=10, pady=8)
    
    label3.grid(row=1, column=0, padx=10, pady=8)
    entry3.grid(row=1, column=1, padx=10, pady=8)

    label4.grid(row=1, column=2, padx=10, pady=8)
    entry4.grid(row=1, column=3, padx=10, pady=8)

    label5.grid(row=4, column=0, padx=10, pady=8)
    entry5.grid(row=4, column=1, padx=10, pady=8)

    label6.grid(row=4, column=2, padx=5, pady=8)
    entry6.grid(row=4, column=3, padx=5, pady=8)

    label7.grid(row=6, column=0, padx=10, pady=8)
    entry7.grid(row=6, column=1, padx=10, pady=8)

    label8.grid(row=6, column=2, padx=10, pady=8)
    entry8.grid(row=6, column=3, padx=10, pady=8)

    label9.grid(row=8, column=0, padx=10, pady=1)
    entry9.grid(row=8, column=1, padx=10, pady=1)

    label10.grid(row=8, column=3, padx=10, pady=1)
    #entry10.grid(row=8, column=3, padx=10, pady=8)

    # Creazione del bottone per avviare lo script
   
    button3 = tk.Button(root, text="  set SM theta angles   ", command=set_cameras, font=('Times', 15, 'bold'), width=20)
    button3.grid(row=8, column=2, padx=10, pady=10)

    button = tk.Button(root,  text="   set parameters    ", command=start_script, font=('Times', 15, 'bold'), width=20)
    button.grid(row=9, column=2, padx=10, pady=10)

    button2 = tk.Button(root, text="start simulation", command=lambda:[delete(), main()], font=('Times', 15, 'bold'), width=20) 
    button2.grid(row=10, column=2, padx=10, pady=10)
    
    #label11.grid(row=11, column=1, padx=10, pady=8)
    #label11 = tk.Label(root, text="ZIA", font=('Times', 14, 'bold'))
    # Avvio della finestra principale
    #root.destroy()
    root.mainloop()


# this function creates and destroys dynamically the grids where you type the angles' values for the cameras
list_of_cameras = []
ref = []

def set_cameras():

    global cameras, ref, entry

    cameras = int(entry9.get())
    list_of_cameras.append(cameras)
    
    if len(list_of_cameras) == 1:
    	    for i in range(cameras):
    	    	entry = tk.Entry(root)
    	    	entry.insert(0, "45")
    	    	entry.grid(row=9+i, column=3, padx=5, pady=10, ipady=10, ipadx=5)
    	    	ref.append(entry) #store references

    else:
    	index = list_of_cameras[-2]
# I destroy the previous grids using an index that refers to the previous number of cameras set     	
    	for i in range(index):
    		grid_to_remove = ref[i]
    		grid_to_remove.grid_remove()
# I have to clean the storage of previous references in order to fill it with the new ones
    	ref = []
    	
    	for i in range(cameras):
    		entry = tk.Entry(root)
    		entry.insert(0, "45")
    		entry.grid(row=9+i, column=3, padx=5, pady=10, ipady=10, ipadx=5)
    		ref.append(entry) #store new references

    return ref






##############################################################################################

#N = 4 # number of modules per column in each supermodule or unit (baseline is 3 x 3 or 4 x 4)

#M = 4 # number of modules per  row   in each supermodule or unit 

#module_size_a = 5. #cm

#module_size_b = 5. #cm

#h = 20. # cm; heigth of the collimator

#sigma = 7. # significance of the detection for a GRB

#how_many_GRBs = 300. # how many GRB to be extracted from the entire sample

#flag_short_long = 0 # write here 1 for short GRBs to be selected (0 for long GRBs)

###############################################################################################


def define_parameters():

    global k_factor_long, k_factor_short, supermodule_size_a, supermodule_size_b, full_mass, FoV,  supermodule_mass,  collimator_mass, supermodule_total_mass

    module_weight = 447 # grammi di un modulo
    
    supermodule_size_a = module_size_a  * N #cm; full size x of the detector
    supermodule_size_b = module_size_b  * M #cm; full size y of the detector

    XX = 2 * math.atan(supermodule_size_a/h)
    YY = 2 * math.atan(supermodule_size_b/h)
    FoV = round((XX * YY), 2) #/ (math.pi)**2 * 180**2
    collimator_density = 1.2517  # [g/cm3]
    
    collimator_mass = collimator_density * (2 * supermodule_size_a * h + 2 * supermodule_size_b * h )
    supermodule_mass = module_weight * N * M

    supermodule_total_mass = collimator_mass + supermodule_mass 
    full_mass = collimator_mass * how_many_cameras/1000. + supermodule_mass * how_many_cameras/1000.

               
#    print("----------- Supermodule parameters -------------- \n")
#    print("FoV:      %.2f sr"% (FoV), "\n")
#    print("Supermodule size (cm): %.1f x %.1f \n" % (supermodule_size_a, supermodule_size_b))
    
#    print("supermodule (kg)  %.3f\n" % (supermodule_mass/1000.))
#    print("collimator (kg)  %.3f\n" % (collimator_mass/1000.))
#    print("Supermodule + collimator total mass (kg)  %.3f\n" % (supermodule_total_mass/1000.))
    
#    print("----------- Instrument  parameters -------------- \n")
    #print("FoV:      %.2f steradians"% (full_fov), "\n")
#    print("Detector  mass (kg)    %.3f\n" % (supermodule_mass * how_many_cameras/1000.))
#    print("Collimator  mass (kg)  %.3f\n" % (collimator_mass * how_many_cameras/1000.))
#    print("Full instrument mass (kg)  %.3f\n" % (full_mass))
    
    k_factor_long  = total_long_GRBs  / 78.9 / how_many_GRBs
    k_factor_short = total_short_GRBs / 78.9 / how_many_GRBs


    # We have defined the mask size but the mask is actually
    # not present. With the A and B we mean that the collimator
    # aperture can be of different size from the detector:

    #            A        (B in the other direction)
    #      \           /
    #       \         /
    #        \       /
    #         \_____/
    #            a        ( b, in the other direction)

    # In case a = A the collimator walls are perpendicular to
    # the detector plane


    #if family == "short":  flag_short_long == 1 # write here 1 for short GRBs to be selected (0 for long GRBs)
    #if family == "long":   flag_short_long == 0 # write here 1 for short GRBs to be selected (0 for long GRBs)
# °°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°°



def R_factor(theta_deg, phi_deg):
    phi_rad = phi_deg / 180. * math.pi
    #F = (A - a ) / (2 * h) #* math.cos(phi)
    #G = (B - b ) / (2 * h) #* math.sin(phi)

    theta_max = math.atan(math.sqrt(supermodule_size_a**2 + supermodule_size_b**2)/h)/math.pi*180

    if theta_deg > -theta_max and  theta_deg < theta_max:

        theta_rad = theta_deg / 180 * math.pi

        s = (1 - h/supermodule_size_a * abs(math.tan(theta_rad)) * abs(math.sin(phi_rad))) * (1 - h/supermodule_size_b * abs(math.tan(theta_rad)) * abs(math.cos(phi_rad)))
    else:
        s = 0
        
    if s < 0.001: s = 0 
    
    return s




def plot_R():
    R0=[]
    R45=[]

    angle = []

    for t in range(-180, 180):
        angle.append(t)
        R0.append(R_factor(t, 0))
        R45.append(R_factor(t, 45))

    #for t in range(-theta_lim, theta_lim):
    #    angle.append(t)
    #    R.append(R_factor(t,39))
    
    #for t in range(theta_lim, 180):
    #    angle.append(t)
    #    R.append(0)

    R_sorted     = [x for y, x in sorted(zip(angle, R0))]
    angle.sort()

    plt.plot(angle, R0, "*")
    plt.plot(angle, R45, ".")
    plt.show()
 


### SOME USEFUL FUNCTIONS
# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
#  INTERPOLATION given two points (x1,y1) and (x2,y2)
#  we calculate the value of y correspondant to a x
#  which is in between x1 and x2. Linear interpolation

def interpol(vector_x, vector_y, element_x):
    indice1 = -1
    indice2 = -1
    for i in range(len(vector_x) - 1):
        if vector_x[i] <= element_x and vector_x[i+1] >= element_x:
            indice1 = i
            indice2 = i+1
            break
    y2 = vector_y[indice2]
    y1 = vector_y[indice1]
    x2 = vector_x[indice2]
    x1 = vector_x[indice1]
    m = (y2-y1) / (x2-x1)
    q = y1 - m * x1
    y = m * element_x + q
    return y


def nearest(array, value):
    array = np.asarray(array)
    idx = (np.abs(array - value)).argmin()
    return array[idx]

# @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@


def rotation_matrix(axis, theta):
    """
    Return the rotation matrix associated with counterclockwise rotation about
    the given axis by theta radians.
    """
    axis = np.asarray(axis)
    axis = axis / math.sqrt(np.dot(axis, axis))
    a = math.cos(theta / 2.0)
    b, c, d = -axis * math.sin(theta / 2.0)
    aa, bb, cc, dd = a * a, b * b, c * c, d * d
    bc, ad, ac, ab, bd, cd = b * c, a * d, a * c, a * b, b * d, c * d
    return np.array([[aa + bb - cc - dd, 2 * (bc + ad), 2 * (bd - ac)],
                     [2 * (bc - ad), aa + cc - bb - dd, 2 * (cd + ab)],
                     [2 * (bd + ac), 2 * (cd - ab), aa + dd - bb - cc]])


def to_cartesian(lat,lon):
    x = np.cos(lon)*np.sin(lat)
    y = np.sin(lon)*np.sin(lat)
    z = np.cos(lat)
    return [x,y,z]



def make_fov_camera(ax, fig, theta_separazione_camere, which_camera):

    
    XX = 2 * math.atan(supermodule_size_a/h)
    YY = 2 * math.atan(supermodule_size_b/h)


    # the two directions angular width in radians in order to evaluate the FoV
    delta_lat = XX 
    delta_lon = YY 

   
    # lat and lon of the camera used as a model
    # the FoV of the N cameras will be obtained starting from this camera and
    # by rotating thr spherical rectangle of the required uantity
    lat_camera = np.pi/2  
    lon_camera = 0


    # theta rotation around y to get the inclination of the camera with respect to the P/L axis
    thetarr2 = theta_camera[which_camera]/180*np.pi 
    
    lat1x = lat_camera - delta_lat/2
    lat2x = lat_camera - delta_lat/2
    lat3x = lat_camera + delta_lat/2
    lat4x = lat_camera + delta_lat/2

    long1y = - delta_lon/2 
    long2y =   delta_lon/2 
    long3y =   delta_lon/2 
    long4y = - delta_lon/2 
    
    theta, phi =  np.mgrid[0:2*np.pi : 50j ,0:np.pi : 50j]
    x = np.cos(phi)*np.sin(theta)
    y = np.sin(phi)*np.sin(theta)
    z = np.cos(theta)
    
 
    #ax = fig.gca(projection='3d')
    #ax.set_aspect("auto")
    ax.plot_surface(x, y, z, color="black", alpha=0.01)
    
    color = ['darkorange', 'r', 'k', 'g', 'b', 'w', 'y', 'b', 'b', 'b', 'b', 'b', 'b', 'b']
    
    p1 = to_cartesian(lat1x,long1y)
    p2 = to_cartesian(lat2x,long2y)
    p3 = to_cartesian(lat3x,long3y)
    p4 = to_cartesian(lat4x,long4y)
    pc = to_cartesian(lat_camera,0)
   
    r1 = np.dot(rotation_matrix([0,-1,0], thetarr2), p1)
    r2 = np.dot(rotation_matrix([0,-1,0], thetarr2), p2)
    r3 = np.dot(rotation_matrix([0,-1,0], thetarr2), p3)
    r4 = np.dot(rotation_matrix([0,-1,0], thetarr2), p4)
    rc = np.dot(rotation_matrix([0,-1,0], thetarr2), pc)

    camera2_1 = np.dot(rotation_matrix([0,0,1], theta_separazione_camere), r1)
    camera2_2 = np.dot(rotation_matrix([0,0,1], theta_separazione_camere), r2)
    camera2_3 = np.dot(rotation_matrix([0,0,1], theta_separazione_camere), r3)
    camera2_4 = np.dot(rotation_matrix([0,0,1], theta_separazione_camere), r4)
    camera2_c = np.dot(rotation_matrix([0,0,1], theta_separazione_camere), rc)
    
    coordinates = [camera2_1, camera2_2, camera2_3, camera2_4, camera2_1]
    polygon = SphericalPolygon(coordinates)#,inside = camera2_c)
    
    t_vals = np.linspace(0, 1, 100)
    
    result5 = geometric_slerp(camera2_1, camera2_2, t_vals)
    result6 = geometric_slerp(camera2_2, camera2_3, t_vals)
    result7 = geometric_slerp(camera2_3, camera2_4,t_vals)
    result8 = geometric_slerp(camera2_4, camera2_1,t_vals)

    ax.plot(result5[...,0], result5[...,1], result5[...,2], c=color[which_camera])
    ax.plot(result6[...,0], result6[...,1], result6[...,2], c=color[which_camera])
    ax.plot(result7[...,0], result7[...,1], result7[...,2], c=color[which_camera])
    ax.plot(result8[...,0], result8[...,1], result8[...,2], c=color[which_camera])

    return polygon
    
def sample_spherical(npoints, ndim=3):
    vec = np.random.randn(ndim, npoints)
    vec /= np.linalg.norm(vec, axis=0)
    return vec

def make_fov():

    global fov_all
    fig = plt.figure()
    ax = plt.axes(projection='3d')
    array_of_polygon = []
    theta_separazione_camere = 360. / how_many_cameras / 180 * math.pi
    for k in range(int(how_many_cameras)):
        polygon = make_fov_camera(ax, fig, k*theta_separazione_camere, k)
        array_of_polygon.append(polygon)    

    xi, yi, zi = sample_spherical(10000)
    points = []
    for i in range(len(xi)):
    	point=[xi[i],yi[i],zi[i]]
    	points.append(point)
    	
    counts = 0	
    for p in points:
        for i in range(int(how_many_cameras)):
        	if array_of_polygon[i].contains_point(p) == True:
        		counts=counts+1
        		break

    fov_all = round((counts/10000)*4*np.pi,2)
      
    plt.show()

        
        

# ||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
#
#              ARF in X mode and S mode
#
#  Read the two arf files XGIS-X_0deg_v7.arf and
#  XGIS-S_0deg_v7.arf which are for the two XGIS cameras
#  and obtain the effective area of a supermodule

#  DUBBIO: LA RISPOSTA 0 DEG È QUELLA DI DUE CAMERE CHE SONO
#  QUINDI ENTRAMBE OFF-AXIS DI 20 GRADI CIASCUNA OPPURE È LA RISPOSTA
#  ON-AXIS DI UNA SINGOLA CAMERA?
#  SUPPONGO PER ORA SIA LA RISPOSTA DI UNA SINGOLA CAMERA
#  E QUINDI DIVIDO PER 100 moduli E MOLTIPLICO PER N (N numero di MODULI)
#  N è una variabile, si veda RIGA 15 del codice
#  (baseline è 16 moduli = 4 x 4)
#  From XGIS-X We also multiply by 2 because of the presence of the
#  mask in Theseus/XGIS, while in GAMOV/XGIS we do not use the mask.

#  For XGIS-S these is not the factor 2 as th mask is fully
#  transparent

#  Open the fits file and normalize the effective area of a
#  Camera by dividing per 100 and multiplying per N = total
#  number of module for each Gamov supermodules

#hdulist = fits.open('XGIS-X_0deg_v7.arf')
#hdulist[1].data['SPECRESP'] = hdulist[1].data['SPECRESP']/100. * N * 2
#hdulist.writeto('supermodule-XGIS-X_0deg_v7.arf')


#  For S mode the scaling factor is between 2 and 1:
#  -a factor epsilon = 2 for low energies as the mask is 100% opaque;
#  -a factor epsilon = x for higher energies (x between 1 and 2)
#  as the mask is 0% opaque i.e. fully transparent;

#  To do this, I need to read Tungsten dat file with 2 columns
#  (energy and mu). For any given energy find the two values
#  lower and upper in the file, and interpolate in order to find
#  the  corresponding mu.

def make_supermodule_area():
    
    hdulist = fits.open('XGIS-X_0deg_v7.arf')
    hdulist[1].data['SPECRESP'] = hdulist[1].data['SPECRESP']/100. * N * 2
    hdulist.writeto('supermodule-XGIS-X_0deg_v7.arf', overwrite=True)

    with open('W_mu_keV.dat', 'r') as f:
        energy_table = []
        mu_table = []
        for riga in f:
            valori = riga.split()
            energy_table.append(float(valori[0]))
            mu_table.append(float(valori[1]))

    hdulist = fits.open('XGIS-S_0deg_v7.arf')
    energy_s=hdulist[1].data['ENERG_LO']
    area_s=hdulist[1].data['SPECRESP']

    mu_s=[]
    for ene in energy_s:
        mu_value = interpol(energy_table, mu_table, ene)
        mu_s.append(mu_value)

    ##################################################
    ## MASK material and thickness of THESEUS/XGIS
    rho = 19.3       # density of Tungsten [g/cm3]
    thickness = 0.1  # cm [1 mm thick coded mask]
    ##################################################

    # Estimation of the area of 1 Gamov-xgis supermodule
    # made of N modules (baseline is 16 modules = 4 x 4).
    # The factor  / 100 * N corresponds to the 100 modules
    # for each XGIS camera and to N modules for each
    # gamov-supermodule.

    area_s_new=[]
    for i in range(0, len(mu_s)):
        exponential = mu_s[i] * rho * thickness
        ar =  2 * area_s[i] / ( 1 + math.exp(-exponential)) / 100 * N
        area_s_new.append(ar)

    hdulist[1].data['SPECRESP'] = area_s_new
    hdulist.writeto('supermodule-XGIS-S_0deg_v7.arf', overwrite=True)




#######################################################################
#######################################################################
# Unisco i due fits file per ottenere una singola area
#######################################################################
#######################################################################



def make_arf():

    global  interp_arf1,  interp_arf2, e1, e2, e3, e4
    hdulist1 = fits.open('supermodule-XGIS-X_0deg_v7.arf')
    hdulist2 = fits.open('supermodule-XGIS-S_0deg_v7.arf')

    # ottieni i dati di interesse
    data1 = hdulist1[1].data
    e1 = data1.field('ENERG_LO')
    e2 = data1.field('ENERG_HI')
    arf1 = data1.field('SPECRESP')

    data2 = hdulist2[1].data
    e3 = data2.field('ENERG_LO')
    e4 = data2.field('ENERG_HI')
    arf2 = data2.field('SPECRESP')

    # calcola il binning energetico comune

    #e_min = min(e1[0], e3[0])
    #e_max = max(e2[-1], e4[-1])

    #e = np.logspace(np.log10(e_min), np.log10(e_max), num=300)

    # effettua l'interpolazione dei dati sui nuovi bin di energia
    interp_arf1 = interp1d(e1, arf1, kind='linear')
    interp_arf2 = interp1d(e3, arf2, kind='linear')
    
    
def area(e_i):
    
    emin_x =  e1[0]
    emax_x =  e1[-1]

    emin_s = e3[0]
    emax_s = e3[-1]

    e = np.linspace(emin_x, emax_s, num = int((emax_s - emin_x)))
    e_x = np.linspace(emin_x, emin_s, num = int((emin_s - emin_x)))
    e_s = np.linspace(emin_s, emax_s, num = int((emax_s - emin_s)))

    areaarf1=interp_arf1(e_x)    
    areaarf2=interp_arf2(e_s)
        
    arf = np.zeros_like(e)
    for i, ei in enumerate(e):
        
        if ei < emin_s: #[0] and ei < e2[-1]:
        
            arf[i] += interp_arf1(ei)
            
        else:
            #if ei > e3[0] and ei < e4[-1]:
            arf[i] += interp_arf2(ei)
            #arf[i] = arf[i]/2 + interp_arf2(ei)/2
            
    idx = (np.abs(e - e_i)).argmin()
    
    return arf[idx]





# ------------------------------------------------------
# 
# Diffuse background evaluation 
#
# ------------------------------------------------------

# COSMIC PHOTON BACKGROUND from Gruber et al. Astrophys. J. 520, 124 (1999)
# derived from HEAO-1 A4 and COMPTEL measurements. Calculation reported in
# Campana et al. 2013

#photons cm−2 s−1 sr−1 keV−1
def diffuse_bkg(ee):
    if ee < 60:
        F = 7.877 * ee**(-1.29) * math.exp(-ee/41.13)
    else:
        A = 0.0004317 * (ee/60)**(-6.5)
        B = 0.0084000 * (ee/60)**(-2.58)
        C = 0.0004800 * (ee/60)**(-2.05)        
        F = A + B + C        
    return F

#photons cm−2 s−1 sr−1 keV−1
def albedo_bkg(ee):
    factor1 = (ee / 33.7)**(-5) 
    factor2 = (ee / 33.7)**(1.72) 
    albedo = 0.0148  / (factor1 + factor2)
    return albedo



##  This function sum and integrate diffuse and albedo bkg
##  between two energies E1 and E2
def integrated_bkg(e1, e2):
    albedo=0
    diffuse=0
    for ee in range(e1, e2):
        factor1 = (ee / 33.7)**(-5) 
        factor2 = (ee / 33.7)**(1.72) 
        albedo = albedo + 0.0148  / (factor1 + factor2)
        if ee < 60:
            F = 7.877 * ee**(-1.29) * math.exp(-ee/41.13)
        else:
            A = 0.0004317 * (ee/60)**(-6.5)
            B = 0.0084000 * (ee/60)**(-2.58)
            C = 0.0004800 * (ee/60)**(-2.05)        
            F = A + B + C       
        diffuse = diffuse + F
    total_bkg = albedo + diffuse

    return total_bkg



       
## IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
##
## Geometric factor for diffuse background correction
## (multiply the value of the diffuse background by this value 
## which depends on the camera geometry and calculate the diffuse
## background as function of the FoV and area of the detector
##

##  The units of this factor are [steradians * cm2]
##  therefore when we multiply the albedo_bkg and
##  diffuse_bkg by this value we obtain ph s-1 keV-1
## IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

def geometric_corr2(x, y, h):

    P1 = math.sqrt( y**2 + h**2)
    P2 = math.sqrt( x**2 + h**2)

    T1 = 2 * x * P1 * np.arctan(x/P1)

    T2 = 2 * y * P2 * np.arctan(y/P2)

    T3 = 2 * x * h * np.arctan(x/h)

    T4 = 2 * y * h * np.arctan(y/h)

    T5 = h**2 * math.log(P1**2 * P2**2 / (h**2 * (h**2 + x**2 + y**2)))

    FG = T1 + T2 - T3 - T4 + T5

    return FG

def geometric_corr(EL,ES,IL,IS,H):

    C1=(EL+IL)**2+H**2
    C2=H**2+(ES+IS)**2
    C3=(EL-IL)**2+H**2
    C4=H**2+(ES-IS)**2
    
    T1=2*(ES+IS)*math.sqrt(C1)*np.arctan( (ES+IS) / C1)
    T2=2*(EL+IL)*math.sqrt(C2)*np.arctan( (EL+IL) / C2)
    T3=2*(ES+IS)*math.sqrt(C3)*np.arctan( (ES+IS) / C3)
    T4=2*(EL-IL)*math.sqrt(C2)*np.arctan( (EL-IL) / C2)
    T5=2*(ES-IS)*math.sqrt(C1)*np.arctan( (ES-IS) / C1)
    T6=2*(EL+IL)*math.sqrt(C4)*np.arctan( (EL+IL) / C4)
    T7=2*(ES-IS)*math.sqrt(C3)*np.arctan( (ES-IS) / C3)
    T8=2*(EL-IL)*math.sqrt(C4)*np.arctan( (EL-IL) / C4)
    
    T9a=H**2 + (ES+IS)**2 + (EL+IL)**2
    T9b=H**2 + (ES-IS)**2 + (EL-IL)**2
    T9c=H**2 + (ES+IS)**2 + (EL-IL)**2
    T9d=H**2 + (ES-IS)**2 + (EL+IL)**2
    
    
    T9= H**2 * np.log( (T9a*T9b) / (T9c*T9d) )
    
    FG= T1 + T2 - T3 - T4 - T5 - T6 + T7 + T8  - T9
    
    return FG	


## IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII





## We consider different criteria for the detection
## and significance for each simulated GRB
## 1. Peak flix (is in 1 sec)

def GRB_sky():
    
    k1 =[]
    k2 = []

    for i in range(0,int(how_many_GRBs)):
        w = random.uniform(0, 1)
    
        #theta_random = math.acos(w)#random.uniform(0, math.acos(w))#
        theta_random = math.asin((2*w)-1)
        phi_random = random.uniform(-math.pi, math.pi)

        k1.append( phi_random )#/ math.pi * 180)
        k2.append(theta_random)# / math.pi * 180)

    sizes = np.random.uniform(5, 5, len(k1))

    #fig = plt.figure()
    #ax = fig.add_subplot(projection='polar')
    #c = ax.scatter(k2, k1, s = sizes)
    #plt.show()


    plt.figure()
    plt.subplot(111, projection="aitoff")
    #plt.subplot(111, projection="lambert")
    plt.grid(True)
    plt.plot(k1, k2, 'o', markersize=2, alpha=1)
    plt.show()


def grb_extractor():

    # ..............................................................
    # ..............................................................
    # Read the GRB population fits file and get a random
    # element of the list

    # Open the GRB population FITS file
    hdulist = fits.open('XGIS_TRIGEF_V06b.fits')
    
    # Get the first extension
    hdu = hdulist[1]

    # Read how many lines in this extension, i.e.
    # how many GRBs have been generated
    n_lines = len(hdu.data)

    # inizilize the GRB which has 11 elements from fluence to the SXI detection flag...
    
    GRB = np.full(11, 2)

    # artificial way to extract only long (flag = 0) or short (flag = 1) GRBs
    # corresponds to element 7 of the vector
    while not (GRB[7] == flag_short_long):
        # Generate a random number between 0 and n_lines-1
        random_GRB_number = random.randint(0, n_lines-1)
        # Read the random line and generate random position   
        GRB = np.array(hdu.data[random_GRB_number])

    w = random.uniform(0, 1)
    
    GRB_theta = math.asin((2*w)-1)   #random.uniform(0, 1math.pi/20)
    GRB_phi   = random.uniform(-math.pi, math.pi)
    
    GRB = np.append(GRB, GRB_theta)
    GRB = np.append(GRB, GRB_phi)

    # Close the FITS file
    hdulist.close()
    return(GRB)
    # .............................................................
    # .............................................................


def integra(vector, start, stop):
    interval = np.arange(start, stop)
    summ = np.trapz(vector[interval])
    return summ

# return the fluence in the whole energyband of the vector
def fluence(vector):
    interval = np.arange(0,len(vector))
    summ = np.trapz(vector[interval])
    return summ


##  background integrated in 10 keV - 1 MeV
##  as specified in Mereghetti note and is
##  albedo + diffuse  (see above)
##  Geometric correction on the background is also applied



def peakflux(grb_element):
    grb_flux = grb_element[1]
    total_area= 10000 #to be written
    signal = grb_flux * total_area
    background = integrated_bkg(10,1000) #* geometric_corr(a,b,A,B,h) 
    snr = math.sqrt(signal + background) / background 

    return snr




def Band_norm(grb_element):
    Fluence_10_1000   = grb_element[0]
    alpha             = grb_element[2]
    beta              = grb_element[3]
    e_peak            = grb_element[4]
    duration          = grb_element[5]
    e_0 = e_peak / ( 2 + alpha)
    e_break = (alpha - beta) * e_0

    total = 0
    for energy in range (1, 1000):
        if energy < e_break:
            exp1 = math.exp(-energy / e_0)
            f = (energy / 100)**(alpha) * exp1
        else:
            exponent2 = (beta-alpha)*(energy/100)**beta 
            exp2 = math.exp(exponent2) 
            f = (e_break / 100)**(alpha-beta) * exp2

        total = total + f
   
    N_0 = Fluence_10_1000 / (duration * total)

    return N_0

 
#ph cm-2 s-1 keV-1
def band(grb_element, energy):

    Fluence_10_1000   = grb_element[0]
    alpha             = grb_element[2]
    beta              = grb_element[3]
    e_peak            = grb_element[4]
    duration          = grb_element[5]
    
    e_0 = e_peak / ( 2 + alpha)
    e_break = (alpha - beta) * e_0
    
    if energy < e_break:
        exp1 = math.exp(-energy / e_0)
        f = Band_norm(grb_element) * (energy / 100)**(alpha) * exp1
    else:
        exponent2 = (beta-alpha)*(energy/100)**beta 
        exp2 = math.exp(exponent2) 
        f = Band_norm(grb_element) * (e_break / 100)**(alpha-beta) * exp2

    return f




############################################################
############################################################
############################################################
####           CORREGGERE
############################################################
############################################################
############################################################

##  ph cm-2 s-1 keV-1
##  give in output a vector from e1 to e2

def band_deltaE(grb_element, a_t, e1, e2, camera_theta, camera_phi): 

    bandfunction=[]
    Fluence_10_1000   = grb_element[0]
    alpha     = grb_element[2]
    beta      = grb_element[3]
    e_peak    = grb_element[4]
    duration  = grb_element[5]

    theta_angle, phi_angle = burst_coordinate_converter(grb_element[10]/math.pi*180., grb_element[11]/math.pi*180., camera_theta, camera_phi)
    
    #theta_angle = grb_element[10]/math.pi*180.
    #phi_angle =   grb_element[11]/math.pi*180.

    e_0 = e_peak / ( 2 + alpha)
    e_break = (alpha - beta) * e_0

    R = R_factor(theta_angle, phi_angle) 
    #print("Fattore correttivo", theta_angle, phi_angle, R)
    for energy in range(e1, e2):
        
        #a = area(energy)    
        if energy < e_break:
            exp1 = math.exp(-energy / e_0)
            f = Band_norm(grb_element) * (energy / 100)**(alpha) * exp1
        else:
            exponent2 = (beta-alpha)*(energy/100)**beta 
            exp2 = math.exp(exponent2) 
            f = Band_norm(grb_element) * (e_break / 100)**(alpha-beta) * exp2
        
        bandfunction.append(f*a_t[energy-e_min]*R)

    return bandfunction





#  This is a new version of the above function to take into account that
#  a given GRB is seen from different cameras with different angles
#  theta_angle and phi_angle are theta_angle_i and phi_angle_i depending
#  on the i-camera

def band_deltaE_multiple_cameras(grb_element, a_t, e1, e2, theta_angle, phi_angle):
    
    bandfunction=[]
    Fluence_10_1000   = grb_element[0]
    alpha     = grb_element[2]
    beta      = grb_element[3]
    e_peak    = grb_element[4]
    duration  = grb_element[5]
    theta_angle = grb_element[10]/math.pi*180.
    phi_angle =   grb_element[11]/math.pi*180.

    e_0 = e_peak / ( 2 + alpha)
    e_break = (alpha - beta) * e_0

    R = R_factor(theta_angle, phi_angle) 
    #print("Fattore correttivo", theta_angle, phi_angle, R)
    for energy in range(e1, e2):
        
        #a = area(energy)    
        if energy < e_break:
            exp1 = math.exp(-energy / e_0)
            f = Band_norm(grb_element) * (energy / 100)**(alpha) * exp1
        else:
            exponent2 = (beta-alpha)*(energy/100)**beta 
            exp2 = math.exp(exponent2) 
            f = Band_norm(grb_element) * (e_break / 100)**(alpha-beta) * exp2
        
        bandfunction.append(f * a_t[energy-e_min] * R)
        # E' corretto utilizzare R qui?

    return bandfunction







# nel bkg c'è integra(a_tt) perchè devo moltiplicare anche il fondo per l'area efficace
def fluence_duration(grb_element, fract_fluence, fract_duration, a_t, emin, emax):
  
    a_tt = np.array(a_t)
    
    theta_angle = grb_element[10]/math.pi*180.
    phi_angle =  grb_element[11]/math.pi*180.

    print("ENERGIE", emin, emax)
    R = R_factor(theta_angle, phi_angle)

    v = np.array(band_deltaE(grb_element, a_t, emin, emax))
    
    grb_fluence = fluence(v) * grb_element[5] * fract_fluence
    grb_duration = grb_element[5] * fract_duration
    total_area= integra(a_tt, int(emin-e_min), int(emax-e_min)) * R 
    signal = grb_fluence * total_area

    if flag_short_long == 0: # extracted long burst from the fits population table
        background = integrated_bkg(emin, emax) * grb_duration  * integra(a_tt, int(emin-e_min), int(emax-e_min)) * geometric_corr2(module_size_a, module_size_b, h) / (module_size_a * module_size_b)

    else: #extracted short GRBs and background is estimated only on 64 ms
        background = integrated_bkg(emin, emax) * 0.0064  * geometric_corr2(module_size_a, module_size_b, h)
        
    #snr2 = math.sqrt(signal + background) / background
    #snr = signal / math.sqrt(background)
    #snr = signal / background
    snr = signal / math.sqrt(background)
    
    return snr



# nel bkg c'è integra(a_tt) perchè devo moltiplicare anche il fondo per l'area efficace

# in this version we use multiple cameras
# paramter = n-cameras given earlier

# array_theta and array_phi are two arrays of the GRB coordinates, each couple of coordinates for each camera of the system
def cumulative_area_multiple_cameras(grb_element, fract_fluence, fract_duration, a_t, emin, emax, array_theta_angle, aray_phi_angle):
    
    a_tt = np.array(a_t)
    R = R_factor(theta_angle, phi_angle) 
    v = np.array(band_deltaE(grb_element, a_t, emin, emax))
    grb_fluence = fluence(v) * grb_element[5] * fract_fluence
    grb_duration = grb_element[5] * fract_duration
    total_area= integra(a_tt, int(emin-e_min), int(emax-e_min)) * R 
    signal = grb_fluence * total_area
    


def fluence_duration_multiple_cameras(grb_element, fract_fluence, fract_duration, a_t, emin, emax, camera_theta, camera_phi):

    burst_theta = grb_element[10]/math.pi*180.
    burst_phi = grb_element[11]/math.pi*180.

    theta_angle, phi_angle = burst_coordinate_converter(burst_theta, burst_phi, camera_theta, camera_phi)

    a_tt = np.array(a_t)
    
    #theta_angle = grb_element[10]/math.pi*180.
    #phi_angle =  grb_element[11]/math.pi*180.


    R = R_factor(theta_angle, phi_angle)
    #print("Orientation", camera_theta, camera_phi)
    #print("GRB angles wrt to the camera", theta_angle, phi_angle)
    #print("Projection factor R                 ", R)
    #print("  ")
    v = np.array(band_deltaE(grb_element, a_t, emin, emax, camera_theta, camera_phi))
    
    grb_fluence = fluence(v) * grb_element[5] * fract_fluence
    grb_duration = grb_element[5] * fract_duration
    total_area= integra(a_tt, int(emin-e_min), int(emax-e_min)) * R 
    signal = grb_fluence * total_area

    if flag_short_long == 0: # extracted long burst from the fits population table
        background = integrated_bkg(emin, emax) * grb_duration  * integra(a_tt, int(emin-e_min), int(emax-e_min)) * geometric_corr2(module_size_a, module_size_b, h) / (module_size_a * module_size_b)

    else: #extracted short GRBs and background is estimated only on 64 ms
        background = integrated_bkg(emin, emax) * 0.0064  * geometric_corr2(a, b, h)
        
    snr2 = math.sqrt(signal + background) / background
    snr = signal / background
    return snr



def make_a_total():

    make_arf()

    a_total=[]
    for energy in range(int(e_min), int(e_max)):
        a_total.append(area(energy))
        
    return a_total



def make_grid():
    grid_theta = np.linspace(0, 90, 10)
    grid_phi = np.linspace(0, 360, 10)
    #grid_theta = grid_theta_r/np.pi*180
    #grid_phi = grid_phi_r/np.pi*180
    grid_point = []
    
    for i in range(len(grid_phi)):
    	for j in range (len(grid_theta)):
    		point = [grid_theta[j], grid_phi[i]]
    		grid_point.append(point) 	

    return grid_point
    
def make_efficiency(grid_element, a_t, emin, emax, camera_theta, camera_phi):
    
    theta_angle, phi_angle = burst_coordinate_converter(grid_element[0], grid_element[1], camera_theta, camera_phi)
    a_tt = np.array(a_t)
    R = R_factor(theta_angle, phi_angle)
    total_area = integra(a_tt, int(emin-e_min), int(emax-e_min)) * R 
    #print("R", R) 
    return total_area


def start_script():
    
    global N, M, module_size_a, module_size_b, h, sigma, how_many_GRBs, flag_short_long, how_many_cameras, theta_camera
    N = float(entry1.get())
    M = float(entry2.get())
    module_size_a =float( entry3.get())
    module_size_b = float(entry4.get())
    h = float(entry5.get())
    sigma = float(entry6.get())
    how_many_GRBs = float(entry7.get())
    flag_short_long = float(entry8.get())
    how_many_cameras = float(entry9.get())
    theta_camera = np.zeros(cameras)
    i=0
    for e in ref:
    	theta_camera[i] = e.get()
    	i = i+1
  
    supermodule_size_a = module_size_a  * N #cm; full size x of the detector
    supermodule_size_b = module_size_b  * M #cm; full size y of the detector
    
    XX = 2 * math.atan(supermodule_size_a/h)
    YY = 2 * math.atan(supermodule_size_b/h)
    
    
    
    define_parameters()
    plot_R()
    GRB_sky()
    make_supermodule_area()
    make_fov()
    

    
        
def Rx(theta):
  return np.matrix([[ 1, 0           , 0           ],
                   [ 0, math.cos(theta),-math.sin(theta)],
                   [ 0, math.sin(theta), math.cos(theta)]])
 
def Ry(theta):
  return np.matrix([[ math.cos(theta), 0, math.sin(theta)],
                   [ 0           , 1, 0           ],
                   [-math.sin(theta), 0, math.cos(theta)]])
 
def Rz(theta):
  return np.matrix([[ math.cos(theta), -math.sin(theta), 0 ],
                   [ math.sin(theta), math.cos(theta) , 0 ],
                   [ 0           , 0            , 1 ]])



#####################################################################
# all 4 angles burst and camera theta and phi must be given in degrees
 ## NB the 2 output angles are in degrees
#####################################################################
def burst_coordinate_converter(burst_theta, burst_phi, camera_theta, camera_phi):

    x = np.sin(burst_theta/180.*math.pi)*np.cos(burst_phi/180.*math.pi)
    y = np.sin(burst_theta/180.*math.pi)*np.sin(burst_phi/180.*math.pi)
    z = np.cos(burst_theta/180.*math.pi)

    grb_cartesian_spacecraft = [x,y,z]
    grb_cartesian_spacecraft_t = np.transpose(grb_cartesian_spacecraft)
    
    #v1=np.dot(grb_cartesian_spacecraft,Rx(camera_theta/180.*math.pi))
    #v1a=np.dot(v1,Rz(camera_phi/180.*math.pi))
    #v1=np.dot(grb_cartesian_spacecraft,Rz(camera_phi/180.*math.pi))
    #v1a=np.dot(v1,Rx(camera_theta/180.*math.pi))
    
    v1 = np.dot(Rz(camera_phi/180.*math.pi), grb_cartesian_spacecraft_t)
    v1_t = np.transpose(v1)
    v1a = np.dot(Rx(camera_theta/180.*math.pi), v1_t)
    
    grb_cartesian_camera1=[v1a[0],v1a[1],v1a[2]]

    grb_theta_new = math.atan(math.sqrt(grb_cartesian_camera1[0]**2+grb_cartesian_camera1[1]**2)/grb_cartesian_camera1[2]) 
    grb_phi_new = math.atan(grb_cartesian_camera1[1]/(grb_cartesian_camera1[0]+0.0000000000000001))
    
    return grb_theta_new/math.pi*180, grb_phi_new/math.pi*180


def nextnonexistent(f):
    fnew = f
    root, ext = os.path.splitext(f)
    i = 0
    while os.path.exists(fnew):
        i += 1
        fnew = '%s_%i%s' % (root, i, ext)
    return fnew


def main():

    if flag_short_long == 0:    flag_label = "long"
    elif flag_short_long == 1:  flag_label = "short"
    
     
    a_total=make_a_total()

#Building the efficiency table: the space has been mapped with a grid,
#for each point of the grid we assign its efficiency

    file_efficiency = open("efficiency_table.txt", "w")
    file_efficiency.write("Coordinates (theta,phi) of a grid's point		Efficiency 		Sum of the area\n")
    
    grid_points = make_grid()
    grid_area_matrix = []
    area_vector = np.zeros(int(how_many_cameras))
    area = []
    sum_area = 0
    
    for i in range (len(grid_points)):
    	for z in range(int(how_many_cameras)):
    		phi_camera = z * 360 / (how_many_cameras)
    		area_vector[z] = np.around(make_efficiency(grid_points[i], a_total, e_min, e_max, theta_camera[z], phi_camera), 3)
    		sum_area = sum_area + area_vector[z] 
		
    	grid_area = [grid_points[i], area_vector]
    	grid_area_matrix.append(grid_area)
    	max_area = np.max(area_vector)
    	efficiency = area_vector/max_area
    	
    	efficiency_r = np.around(efficiency, 2)
    	efficiency_string_array = [str(element) for element in efficiency_r]
    	efficiency_string = ' '.join(efficiency_string_array)
    	
    	file_efficiency.write("%.3f %.3f %s %.3f \n"%(grid_points[i][0],grid_points[i][1],efficiency_string,sum_area))
    	
    	sum_area = 0
    
    
    '''efficiency = area/max_area
    number_of_cameras = int(how_many_cameras)
    divide = len(area)/number_of_cameras
    efficiency_vectors = np.split(efficiency, divide)
    
    for i in range (len(grid_points)):
    	efficiency_r = np.around(efficiency_vectors[i], 2)
    	efficiency_string_array = [str(element) for element in efficiency_r]
    	efficiency_string = ' '.join(efficiency_string_array)
    	file_efficiency.write("%.3f %.3f %s \n"%(grid_points[i][0],grid_points[i][1],efficiency_string))'''	
    
    file_efficiency.close()
    
    counts = np.zeros(int(how_many_cameras))
    counts_z_higher_than_5 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_6 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_7 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_8 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_9 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_10 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_11 = np.zeros(int(how_many_cameras))
    counts_z_higher_than_12 = np.zeros(int(how_many_cameras))
    
    root2 = tk.Tk()
    root2.title("XGIS / GAMOV - GRB rate estimator")
    # crea la progress bar
    progress = ttk.Progressbar(root2, orient="horizontal", length=500, mode="determinate")
    progress.pack(pady=10)
    progress_text_var = tk.StringVar()
    progress_text_var.set("Elaborazione in corso...")
    progress_text = ttk.Label(root2, textvariable=progress_text_var)
    progress_text.pack(pady=5)

    filename = str(int(how_many_GRBs))+flag_label+"GRBs_"+str(int(how_many_cameras))+"SM_"+str(int(theta_camera[0]))+"deg.txt"
    
    filename = nextnonexistent(filename)
                    
    f = open(filename, "w")
    f.write("---------  Input parameters  ------------" + '\n')
    f.write("Significance: " + str(sigma) + '\n')
    f.write("How many cameras: " + str(how_many_cameras) + '\n')
    f.write("Extracted GRBs: " + str(how_many_GRBs) + '\n')
    f.write("collimator heigth: " + str(h) + '\n')
    f.write("theta cameras: " + str(theta_camera) + '\n')
    f.write('\n')
    f.write("---------  Output parameters -----------" + '\n')
    f.write("SM FoV: " + str(FoV) + ' sr \n')
    f.write("SM size a: " + str(supermodule_size_a) + '\n')
    f.write("SM size b: " + str(supermodule_size_b) + '\n')
    f.write("SM mass: " + str(supermodule_mass/1000.) + '\n')
    f.write("collimator mass: " + str(collimator_mass/1000.) + ' kg \n')
    f.write("total SM mass: " + str(supermodule_total_mass/1000.) + ' kg \n')
    f.write("Instrument mass: " + str(full_mass) + '\n')
    f.write("Instrument FoV: " + str(fov_all) + ' sr \n')
    f.write('\n')
    f.write("---------  GRB detection log ------------" + '\n')
        
    progressive_num_of_grb_detected = 0

    f.write("N   long/short    SNR/camera   fluence 10/1000   grb_flux   alpha   beta   epeak    T   z   flag s/l   Jflux   SXI   GRB-theta   GRB-phi\n")
    f.write('\n')
    
    for i in range (0, int(how_many_GRBs)):
        
        progress["value"] = 100/how_many_GRBs * i
        percentage = i / how_many_GRBs * 100
        progress_text_var.set(f" GRB {i+1} / %.0f in progress              (%.1f %%)" % (how_many_GRBs, percentage) )
        # aggiorna la finestra
        root2.update()

        grb_element=grb_extractor()

        redshift = grb_element[6]

        #print(" ")
        #print("--------------------------------------------------------")
        #print("GRB theta and phi wrt P/L axis", grb_element[10]/math.pi*180, grb_element[11]/math.pi*180)
        
        # UPDATE: we calculate here SNR for each camera therefore SNR is a vector of H elements with H = number of cameras.
        # we also have counts as a vector counts[0] = number of GRB detected by camera 1, counts[1] = number
        # of GRBs detected by camera 2 etc etc.

        snr = []
                           
        for z in range (0, int(how_many_cameras)):
            
            #theta_camera = 20.     # 20 degrees similarly to XGIS
            phi_camera = z * 360 / (how_many_cameras)
                    
            snr.append(fluence_duration_multiple_cameras(grb_element, 1, 1, a_total, e_min, e_max, theta_camera[z], phi_camera))
            
            
        flag_label=[]
        if any(y > sigma for y in snr):
            if flag_short_long == 0:    flag_label = "long"
            elif flag_short_long == 1:  flag_label = "short"
            else:
                break
            
            snr_r = np.around(snr, 2)
            snr_string_array = [str(element) for element in snr_r]
            snr_string = ' '.join(snr_string_array)
         

            
            #f.write(str(total_num_of_grb_detected) + str(flag_label) + " GRB "+ str(i) + " detected -" " Significance per SM " + str(np.around(snr,2)) + str(grb_element) + '\n')
            #f.write(str(total_num_of_grb_detected) + str(flag_label) + str(grb_element[0]) +  str(grb_element[1]) + str(grb_element[2]) +  str(grb_element[3]) + str(grb_element[4]) +  str(grb_element[5]) + str(grb_element[6]) +  str(grb_element[7]) + str(grb_element[8]) +  str(grb_element[9]) + str(grb_element[10]) +  str(grb_element[11]) + '\n')
            
            f.write("%.0f  %s  %s  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f  %.3f\n" % (progressive_num_of_grb_detected, flag_label, snr_string, grb_element[0], grb_element[1], grb_element[2], grb_element[3], grb_element[4], grb_element[5], grb_element[6], grb_element[7], grb_element[8], grb_element[9], grb_element[10], grb_element[11]))

            #position_detection() 
                   
            progressive_num_of_grb_detected =  progressive_num_of_grb_detected + 1

        total_num_of_grb_detected = progressive_num_of_grb_detected

        for z in range (0, int(how_many_cameras)):
            
            if snr[z] > sigma:
                counts[z] = counts[z] + 1
            
                if  redshift > 5:
                    counts_z_higher_than_5[z] = counts_z_higher_than_5[z] + 1
                if redshift > 6:
                    counts_z_higher_than_6[z] = counts_z_higher_than_6[z] + 1
                if redshift > 7:
                    counts_z_higher_than_7[z] = counts_z_higher_than_7[z] + 1
                if redshift > 8:
                    counts_z_higher_than_8[z] = counts_z_higher_than_8[z] + 1
                if redshift > 9:
                    counts_z_higher_than_9[z] = counts_z_higher_than_9[z] + 1
                if redshift > 10:
                    counts_z_higher_than_10[z] = counts_z_higher_than_10[z] + 1
                if redshift > 11:
                    counts_z_higher_than_11[z] = counts_z_higher_than_11[z] + 1
                if redshift > 12:
                    counts_z_higher_than_12[z] = counts_z_higher_than_12[z] + 1
                #else:
                #    print("WARNING: something in redshift went wrong")

                    
    # chiude la finestra alla fine del loop
    root2.destroy()
    
    if flag_short_long == 1:

        short_grb = counts * k_factor_short
        
        short_grb_z5 =  counts_z_higher_than_5 * k_factor_short
        short_grb_z6 =  counts_z_higher_than_6 * k_factor_short
        short_grb_z7 =  counts_z_higher_than_7 * k_factor_short
        short_grb_z8 =  counts_z_higher_than_8 * k_factor_short
        short_grb_z9 =  counts_z_higher_than_9 * k_factor_short
        short_grb_z10 =  counts_z_higher_than_10 * k_factor_short
        short_grb_z11 =  counts_z_higher_than_11 * k_factor_short
        short_grb_z12 =  counts_z_higher_than_12 * k_factor_short
        
        
        # make a string of the short GRB array (N cameras)
        short_grb_r = np.rint(short_grb)
        short_grb_array = [str(element) for element in short_grb_r]
        short_grb_string = ' '.join(short_grb_array)

        short_grb_r_z5 = np.rint(short_grb_z5)
        short_grb_z5_array = [str(element) for element in short_grb_r_z5]
        short_grb_z5_string = ' '.join(short_grb_z5_array)

        short_grb_r_z6 = np.rint(short_grb_z6)
        short_grb_z6_array = [str(element) for element in short_grb_r_z6]
        short_grb_z6_string = ' '.join(short_grb_z6_array)

        short_grb_r_z7 = np.rint(short_grb_z7)
        short_grb_z7_array = [str(element) for element in short_grb_r_z7]
        short_grb_z7_string = ' '.join(short_grb_z7_array)

        short_grb_r_z8 = np.rint(short_grb_z8)
        short_grb_z8_array = [str(element) for element in short_grb_r_z8]
        short_grb_z8_string = ' '.join(short_grb_z8_array)

        short_grb_r_z9 = np.rint(short_grb_z9)
        short_grb_z9_array = [str(element) for element in short_grb_r_z9]
        short_grb_z9_string = ' '.join(short_grb_z9_array)

        short_grb_r_z10 = np.rint(short_grb_z10)
        short_grb_z10_array = [str(element) for element in short_grb_r_z10]
        short_grb_z10_string = ' '.join(short_grb_z10_array)

        short_grb_r_z11 = np.rint(short_grb_z11)
        short_grb_z11_array = [str(element) for element in short_grb_r_z11]
        short_grb_z11_string = ' '.join(short_grb_z11_array)

        short_grb_r_z12 = np.rint(short_grb_z12)
        short_grb_z12_array = [str(element) for element in short_grb_r_z12]
        short_grb_z12_string = ' '.join(short_grb_z12_array)

        #print(short_grb,  "short GRBs / year\n")
        #print(short_grb_z5,  "GRB for z > 5")
        #print(k_factor_short,  "k-factor")
        
        f.write('\n')
        f.write("---------  Summary  ------------" + '\n')
        f.write("Total N of short GRBs in sample:       %.1f\n" % (total_num_of_grb_detected))
        f.write("Short GRBs/y:       %s\n" % (short_grb_string))
        f.write("Short GRBs z > 5 / y: %s\n" % (short_grb_z5_string))
        f.write("Short GRBs z > 6 / y: %s\n" % (short_grb_z6_string))
        f.write("Short GRBs z > 7 / y: %s\n" % (short_grb_z7_string))
        f.write("Short GRBs z > 8 / y: %s\n" % (short_grb_z8_string))
        f.write("Short GRBs z > 9 / y: %s\n" % (short_grb_z9_string))
        f.write("Short GRBs z > 10 / y: %s\n" % (short_grb_z10_string))
        f.write("Short GRBs z > 11 / y: %s\n" % (short_grb_z11_string))
        f.write("Short GRBs z > 12 / y: %s\n" % (short_grb_z12_string))
        f.write('\n')
        f.write("K factor short: %.2f\n" % (k_factor_short))

           



        
    if flag_short_long == 0:

        long_grb = counts * k_factor_long
        
        long_grb_z5 = counts_z_higher_than_5 * k_factor_long
        long_grb_z6 =  counts_z_higher_than_6 * k_factor_long
        long_grb_z7 =  counts_z_higher_than_7 * k_factor_long
        long_grb_z8 =  counts_z_higher_than_8 * k_factor_long
        long_grb_z9 =  counts_z_higher_than_9 * k_factor_long
        long_grb_z10 =  counts_z_higher_than_10 * k_factor_long
        long_grb_z11 =  counts_z_higher_than_11 * k_factor_long
        long_grb_z12 =  counts_z_higher_than_12 * k_factor_long

        
        round_long = [round(num) for num in long_grb]
        round_long5 = [round(num) for num in long_grb_z5]
        
        # make a string of the long GRB array (N cameras)
        long_grb_r = np.rint(long_grb)
        long_grb_array = [str(element) for element in long_grb_r]
        long_grb_string = ' '.join(long_grb_array)

        long_grb_r_z5 = np.rint(long_grb_z5)
        long_grb_z5_array = [str(element) for element in long_grb_r_z5]
        long_grb_z5_string = ' '.join(long_grb_z5_array)


        long_grb_r_z6 = np.rint(long_grb_z6)
        long_grb_z6_array = [str(element) for element in long_grb_r_z6]
        long_grb_z6_string = ' '.join(long_grb_z6_array)

        long_grb_r_z7 = np.rint(long_grb_z7)
        long_grb_z7_array = [str(element) for element in long_grb_r_z7]
        long_grb_z7_string = ' '.join(long_grb_z7_array)

        long_grb_r_z8 = np.rint(long_grb_z8)
        long_grb_z8_array = [str(element) for element in long_grb_r_z8]
        long_grb_z8_string = ' '.join(long_grb_z8_array)

        long_grb_r_z9 = np.rint(long_grb_z9)
        long_grb_z9_array = [str(element) for element in long_grb_r_z9]
        long_grb_z9_string = ' '.join(long_grb_z9_array)

        long_grb_r_z10 = np.rint(long_grb_z10)
        long_grb_z10_array = [str(element) for element in long_grb_r_z10]
        long_grb_z10_string = ' '.join(long_grb_z10_array)

        long_grb_r_z11 = np.rint(long_grb_z11)
        long_grb_z11_array = [str(element) for element in long_grb_r_z11]
        long_grb_z11_string = ' '.join(long_grb_z11_array)

        long_grb_r_z12 = np.rint(long_grb_z12)
        long_grb_z12_array = [str(element) for element in long_grb_r_z12]
        long_grb_z12_string = ' '.join(long_grb_z12_array)


        f.write('\n')
        f.write("---------  Summary  ------------" + '\n')
        f.write("Total N of long GRBs in sample:       %.1f\n" % (total_num_of_grb_detected))
        f.write("Long GRBs/y:       %s\n" % (long_grb_string))
        f.write("Long GRBs z > 5 / y : %s\n" % (long_grb_z5_string))
        f.write("Long GRBs z > 6 / y : %s\n" % (long_grb_z6_string))
        f.write("Long GRBs z > 7 / y : %s\n" % (long_grb_z7_string))
        f.write("Long GRBs z > 8 / y : %s\n" % (long_grb_z8_string))
        f.write("Long GRBs z > 9 / y : %s\n" % (long_grb_z9_string))
        f.write("Long GRBs z > 10 / y : %s\n" % (long_grb_z10_string))
        f.write("Long GRBs z > 11 / y : %s\n" % (long_grb_z11_string))
        f.write("Long GRBs z > 12 / y : %s\n" % (long_grb_z12_string))
        f.write('\n')
        f.write("K factor long: %.2f\n" % (k_factor_long))

     
e_min = int(100.)
e_max = int(150.)

total_long_GRBs = 2000000
total_short_GRBs = 18428

create_gui()





#if __name__ == "__main__":
#    main()




#def grb_cartesian_coordinates(grb_element):
#    grb_theta = grb_element[10]
#    grb_phi =   grb_element[11]
#    x_grb = math.sin(grb_theta) * math.cos(grb_phi)
#    y_grb = math.sin(grb_theta) * math.sin(grb_phi)
#    z_grb = math.cos(grb_theta) 
#    coordinates = [x_grb, y_grb, z_grb] 
#    return coordinates 







